/**
* ============================================
* LazyAnimate - 1.1.0
* Copyright © 2022
*
* @author: Matteo Montanari <matteo@italinux.com>
*
* TERMS OF USE
* Open source under the MIT License.
*
* Permission is hereby granted, free of charge, to any person obtaining
* a copy of this software and associated documentation files (the "Software"),
* to deal in the Software without restriction, including without limitation
* the rights to use, copy, modify, merge, publish, distribute, sublicense,
* and/or sell copies of the Software, and to permit persons to whom the
* Software is furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included
* in all copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR
* IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
* ============================================
* Waypoints required Animations
* ============================================
*
* Start Animations Loop
*/
(function($){$.fn.lazyAnimate=function(options){var maxAnimatedLines=1;var thisSelector=this.selector;var thisHash=$(location).attr("hash").substring(1);var parentHash=thisHash.substr(0,thisHash.lastIndexOf("-"));for(var sectionID in options){var thisObject=options[sectionID];for(var targetEl in thisObject){if(!thisObject.hasOwnProperty(targetEl))continue;var thisTargetLength=Object.keys(thisObject[targetEl]).length;var objsOpts={};var idu=0;switch(getDepthOfObject(thisObject[targetEl])){case 1:objsOpts[0]={element:$(this),target:"*[data-animation='"+targetEl+"']",effect:thisObject[targetEl].effect,delay:thisObject[targetEl].delay,duration:thisObject[targetEl].duration,infinite:thisObject[targetEl].infinite,offset:thisObject[targetEl].offset};break;case 2:for(var id in thisObject[targetEl]){objsOpts[id]={element:$(this),target:"*[data-animation='"+targetEl+"']:eq("+id+")",effect:thisObject[targetEl][id].effect,delay:thisObject[targetEl][id].delay,duration:thisObject[targetEl][id].duration,infinite:thisObject[targetEl][id].infinite,offset:thisObject[targetEl][id].offset};for(idu=parseInt(id,10)+thisTargetLength;idu<thisTargetLength*maxAnimatedLines;idu++){objsOpts[idu]={element:$(this),target:"*[data-animation='"+targetEl+"']:eq("+idu+")",effect:thisObject[targetEl][id].effect,delay:thisObject[targetEl][id].delay,duration:thisObject[targetEl][id].duration,infinite:thisObject[targetEl][id].infinite,offset:thisObject[targetEl][id].offset};idu=idu+thisTargetLength-1}}break;default:doObjectsOptsShowAnimation(thisSelector,"*[data-animation='"+targetEl+"']");return true}if(!thisHash){setObjectsOpts(objsOpts)}else{if(thisHash==sectionID){setObjectsOpts(objsOpts)}else{if(parentHash==sectionID){setObjectsOpts(objsOpts)}else{setObjectsNoAnimations(objsOpts)}}}if(idu>0){var thisTargetOptsLength=Object.keys(objsOpts).length?Object.keys(objsOpts).length-1:0;doObjectsOptsShowAnimation(thisSelector,"*[data-animation='"+targetEl+"']:gt("+thisTargetOptsLength+")")}}}return true};function getDepthOfObject(obj){var level=1;for(var key in obj){if(!obj.hasOwnProperty(key))continue;if(typeof obj[key]=="object"&&obj[key]!==null){var depth=getDepthOfObject(obj[key])+1;level=Math.max(depth,level)}}return level}function setObjectsOpts(objsOpts){for(var objID in objsOpts){var thisElement=objsOpts[objID].element;var thisTarget=objsOpts[objID].target;var thisEffect=objsOpts[objID].effect;var thisDelay=objsOpts[objID].delay;var thisDuration=objsOpts[objID].duration;var thisInfinite=objsOpts[objID].infinite;var thisOffset=objsOpts[objID].offset;switch(thisEffect){case"bounceIn":case"bounceInUp":case"bounceInLeft":case"bounceInRight":case"flipInX":case"flipInY":case"fadeIn":case"fadeInLeft":case"fadeInRight":case"fadeInLeftBig":case"fadeInRightBig":case"fadeInUp":case"fadeInUpBig":case"lightSpeedIn":case"rotateIn":case"slideInLeft":case"zoomIn":case"zoomInRight":case"zoomInUp":case"zoomInDown":case"pulse":case"bounce":case"swing":doObjectsOptsHideAnimation(thisElement,thisTarget);break}doObjectsOptsPrepareForAnimation(thisElement,thisTarget,thisDelay,thisDuration,thisInfinite);doObjectsOptsDoAnimation(thisElement,thisTarget,thisEffect,thisOffset)}}function doObjectsOptsShowAnimation(thisSection,thisTarget){$(thisSection).find(thisTarget).not("[class~='disabled']").removeClass("nopaque")}function doObjectsOptsHideAnimation(thisElement,thisTarget){$(thisElement).each(function(){$(this).find(thisTarget).not("[class~='disabled']").addClass("nopaque")})}function doObjectsOptsPrepareForAnimation(thisElement,thisTarget,thisDelay,thisDuration,thisInfinite){$(thisElement).each(function(){if(thisDelay!==undefined&&thisDelay!==null&&thisDelay!=0){$(this).find(thisTarget).not("[class~='disabled']").addClass("delay-"+thisDelay.toString().replace(/\./g,"")+"s")}if(thisDuration!==undefined&&thisDuration!==null){$(this).find(thisTarget).not("[class~='disabled']").addClass("duration-"+thisDuration.toString().replace(/\./g,"")+"s")}if(thisInfinite!==undefined&&thisInfinite!==null&&thisInfinite!==false){$(this).find(thisTarget).not("[class~='disabled']").addClass("infinite")}})}function doObjectsOptsDoAnimation(thisElement,thisTarget,thisEffect,thisOffset){$(thisElement).each(function(){$(this).find(thisTarget).waypoint({element:$(this),handler:function(e,d){$(this.element).not("[class~='disabled']").removeClass("nopaque animated "+thisEffect).addClass("animated "+thisEffect);this.destroy()},offset:function(d){var topOffset=200;var offset;switch(thisOffset){case"bottom":offset=$(window).height()-this.element.clientHeight;break;default:offset=topOffset+thisOffset;break}return offset}})})}function doObjectsNoAnimations(thisElement,thisTarget){$(thisElement).each(function(){$(this).find(thisTarget).not("[class~='disabled']").removeClass("nopaque")})}function setObjectsNoAnimations(objsOpts){for(var objID in objsOpts){doObjectsNoAnimations(objsOpts[objID].element,objsOpts[objID].target)}}})(jQuery);